/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 19:32:55 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

/**
 * Model definition for JobConfigurationLink.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobConfigurationLink extends com.google.api.client.json.GenericJson {

  /**
   * [Optional] Whether or not to create a new table, if none exists.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String createDisposition;

  /**
   * [Required] The destination table of the link job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TableReference destinationTable;

  /**
   * [Required] URI of source table to link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> sourceUri;

  /**
   * [Optional] Whether to overwrite an existing table (WRITE_TRUNCATE), append to an existing table
   * (WRITE_APPEND), or require that the the table is empty (WRITE_EMPTY). Default is WRITE_APPEND.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String writeDisposition;

  /**
   * [Optional] Whether or not to create a new table, if none exists.
   * @return value or {@code null} for none
   */
  public java.lang.String getCreateDisposition() {
    return createDisposition;
  }

  /**
   * [Optional] Whether or not to create a new table, if none exists.
   * @param createDisposition createDisposition or {@code null} for none
   */
  public JobConfigurationLink setCreateDisposition(java.lang.String createDisposition) {
    this.createDisposition = createDisposition;
    return this;
  }

  /**
   * [Required] The destination table of the link job.
   * @return value or {@code null} for none
   */
  public TableReference getDestinationTable() {
    return destinationTable;
  }

  /**
   * [Required] The destination table of the link job.
   * @param destinationTable destinationTable or {@code null} for none
   */
  public JobConfigurationLink setDestinationTable(TableReference destinationTable) {
    this.destinationTable = destinationTable;
    return this;
  }

  /**
   * [Required] URI of source table to link.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getSourceUri() {
    return sourceUri;
  }

  /**
   * [Required] URI of source table to link.
   * @param sourceUri sourceUri or {@code null} for none
   */
  public JobConfigurationLink setSourceUri(java.util.List<java.lang.String> sourceUri) {
    this.sourceUri = sourceUri;
    return this;
  }

  /**
   * [Optional] Whether to overwrite an existing table (WRITE_TRUNCATE), append to an existing table
   * (WRITE_APPEND), or require that the the table is empty (WRITE_EMPTY). Default is WRITE_APPEND.
   * @return value or {@code null} for none
   */
  public java.lang.String getWriteDisposition() {
    return writeDisposition;
  }

  /**
   * [Optional] Whether to overwrite an existing table (WRITE_TRUNCATE), append to an existing table
   * (WRITE_APPEND), or require that the the table is empty (WRITE_EMPTY). Default is WRITE_APPEND.
   * @param writeDisposition writeDisposition or {@code null} for none
   */
  public JobConfigurationLink setWriteDisposition(java.lang.String writeDisposition) {
    this.writeDisposition = writeDisposition;
    return this;
  }

  @Override
  public JobConfigurationLink set(String fieldName, Object value) {
    return (JobConfigurationLink) super.set(fieldName, value);
  }

  @Override
  public JobConfigurationLink clone() {
    return (JobConfigurationLink) super.clone();
  }

}
